﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows;

namespace WpfApplication1
{
    // Help me snap to device pixels...
    // http://social.msdn.microsoft.com/Forums/en-US/wpf/thread/1fe03c08-8432-4edb-9c4a-34af1adf1fce/
    public class ScrollViewerExt : ScrollViewer
    {
        protected override void OnScrollChanged(ScrollChangedEventArgs e)
        {
            base.OnScrollChanged(e);

            double h = e.HorizontalOffset;
            double v = e.VerticalOffset;

            if (h != Math.Round(h))
            {
                this.ScrollToHorizontalOffset(Math.Round(h));
            }

            if (v != Math.Round(v))
            {
                this.ScrollToVerticalOffset(Math.Round(v));
            }
        }

        //protected override void OnRenderSizeChanged(SizeChangedInfo sizeInfo)
        //{
        //    //base.OnRenderSizeChanged(sizeInfo);

        //    Matrix m = PresentationSource.FromVisual(this).CompositionTarget.TransformToDevice;
        //    double dpiFactor = 1 / m.M11;

        //    double w = sizeInfo.NewSize.Width;
        //    double h = sizeInfo.NewSize.Height;

        //    if (w != Math.Floor(w))
        //    {
        //        this.Width = Math.Floor(w) * dpiFactor;
        //    }

        //    if (h != Math.Floor(h))
        //    {
        //        this.Height = Math.Floor(h) * dpiFactor;
        //    }
        //}
    }
}
